% Illustrate loading MAT file and digital filtering.
%
% Assumes the user has designed bass, midrange, and treble filters using
% fdatools.
% Use FIR design, Rectangular window, order (300), sample rate (44100 s/s)
% bass: 0-320 Hz, midrange: 320-1280 Hz, treble: 1280-22050 Hz.
% Export from fdatools to workspace as coefficients as NumBass,
% NumMidRange, NumTreble. Write to 'demo1_FIR_EQ'.
%
% Author: G.Wakefield, 08OCT14, EECS452F14, University of Michigan
%
[insig, fs] = audioread('SuperstitionSnippet.wav');

% Import filter designs into script and display the frequency response of the parallel
% system. Adjust gains as needed.

load('demo1_FIR_EQ');

gBass = 1;
gMidRange = 0;
gTreble = 0;

hNumEQ = gBass*NumBass + gMidRange*NumMidRange + gTreble*NumTreble;      % parallel FIR = sum component FIRs
freqz(hNumEQ,1,[],fs);

pause

% filter and playback
outsig = filter(hNumEQ,1,insig);

% listen to the original and the filter versions
aPOrg = audioplayer(insig,fs);
playblocking(aPOrg);

aPProc = audioplayer(outsig,fs);
playblocking(aPProc);


