% Repeat demo1_b for IIR case. 
%
% Assumes the user has designed bass, midrange, and treble filters using
% fdatools.
% Use IIR design, Butterworth, minimum order, sample rate (44100 s/s)
% bass: 0-320 Hz (40 dB down at 1000 Hz)
% midrange: 320-1280 Hz (40 dB down at 200 Hz, 40 dB down at 2 kHz)
% treble: 1280-22050 Hz (40 dB down at 900 Hz)
% Export from fdatools to workspace as System Objects: HdBass, HdMidRange,
% HdTrebele. Write to 'demo1_IIR_Butterworth_EQ'.
%
% Author: G.Wakefield, 08OCT14, EECS452F14, University of Michigan
%
% load signal and filters
[insig, fs] = audioread('SuperstitionSnippet.wav');
load('demo1_IIR_Butterworth_EQ');

% display frequency response of each filter
% parallel combination of pole/zero systems
% plot each system separately
figure(1)
[HBass,W] = freqz(HdBass,2048,fs);
[HMidRange,W] = freqz(HdMidRange,2048,fs);
[HTreble,W] = freqz(HdTreble,2048,fs);
plot(W,20*log10(abs(HBass)),'r');
hold on
plot(W,20*log10(abs(HMidRange)),'g');
plot(W,20*log10(abs(HTreble)),'b');
legend('bass','midrange','treble','Location','SouthEast');
v = axis;
v(3) = -100;
v(4) = 10;
grid on
axis(v)
xlabel('frequency [Hz]');
ylabel('Magnitude [dB]');
hold off

pause

% filter and playback
gBass = 1;
gMidRange = 1;
gTreble = 1;

outsigBass = gBass*filter(HdBass,insig);
outsigMidRange = gMidRange*filter(HdMidRange,insig);
outsigTreble = gTreble*filter(HdTreble,insig);

outsig = outsigBass + outsigMidRange + outsigTreble;

% listen to the result
aP = audioplayer(outsig,fs);
playblocking(aP);
