% Illustrate reading, processing, and playing frames of the audio file:
% NAIVE VERSION.
% Expanded use of audioread; querying audio file attributes using
% audioinfo.
%
% Author: G.Wakefield, 08OCT14, EECS452F14, University of Michigan

load('demo1_IIR_Butterworth_EQ');

% break input up into frameSz chunks, process, and concatenate
info = audioinfo('SuperstitionSnippet.wav');

frameSz = 1024;
iStart = 1;
iStop = frameSz;
nSig = info.TotalSamples;

outsigBass = [];
outsigMidRange = [];
outsigTreble = [];

gBass = 1;
gMidRange = 1;
gTreble = 1;

while iStop <= nSig
    [insig, fs] = audioread('SuperstitionSnippet.wav',[iStart iStop]);
    outsigBass = [outsigBass ; gBass*filter(HdBass,insig)];
    outsigMidRange = [outsigMidRange ; gMidRange*filter(HdMidRange,insig)];
    outsigTreble = [outsigTreble ; gTreble*filter(HdTreble,insig)];
    iStart = iStart + frameSz;
    iStop = iStop + frameSz;
end;

outsig = outsigBass + outsigMidRange + outsigTreble;

% listen to the result
aP = audioplayer(outsig,fs);
playblocking(aP);
