function varargout = demo2_c(varargin)
% Refine user interface and usability: load user-specified audio files and
% implement pause/stop functions.
% Author: G.Wakefield, 08OCT14, EECS452F14, University of Michigan

% DEMO2_C MATLAB code for demo2_c.fig
%      DEMO2_C, by itself, creates a new DEMO2_C or raises the existing
%      singleton*.
%
%      H = DEMO2_C returns the handle to a new DEMO2_C or the handle to
%      the existing singleton*.
%
%      DEMO2_C('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DEMO2_C.M with the given input arguments.
%
%      DEMO2_C('Property','Value',...) creates a new DEMO2_C or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before demo2_c_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to demo2_c_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help demo2_c

% Last Modified by GUIDE v2.5 06-Oct-2014 14:48:37

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @demo2_c_OpeningFcn, ...
                   'gui_OutputFcn',  @demo2_c_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before demo2_c is made visible.
function demo2_c_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to demo2_c (see VARARGIN)

% Choose default command line output for demo2_c
handles.output = hObject;

set([handles.pushPlay handles.pushPause handles.pushStop],'Enable','off');
handles.pauseState = false;
handles.stopState = false;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes demo2_c wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = demo2_c_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushLoad.
function pushLoad_Callback(hObject, eventdata, handles)
% hObject    handle to pushLoad (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[fName pName] = uigetfile({'*.wav; *.m4a; *.avi'});
handles.audFileName = [pName fName];

set(hObject,'String','Thank you','Enable','off');
set(handles.pushPlay,'Enable','on');

handles.pauseState = false;
handles.stopState = false;

guidata(hObject,handles);

% --- Executes on button press in pushPlay.
function pushPlay_Callback(hObject, eventdata, handles)
% hObject    handle to pushPlay (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% reuse the demo1_h code

set(hObject,'String','Playing...','Enable','off');
set([handles.pushPause handles.pushStop],'Enable','on');
drawnow

inAudioDev = dsp.AudioFileReader(handles.audFileName);
outAudioDev = dsp.AudioPlayer('SampleRate',inAudioDev.SampleRate);

while ~isDone(inAudioDev) && ~handles.stopState
    if ~handles.pauseState
        sig = step(inAudioDev);
        step(outAudioDev,sig);
    end;
    drawnow
    handles = guidata(hObject);
end

release(inAudioDev);
release(outAudioDev);

set(hObject,'String','Play Me');
set([handles.pushPlay handles.pushPause handles.pushStop],'Enable','off');
set(handles.pushLoad,'String','Load Me','Enable','on');
set(handles.pushPause,'String','Pause');

drawnow


% --- Executes on button press in pushPause.
function pushPause_Callback(hObject, eventdata, handles)
% hObject    handle to pushPause (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if ~handles.pauseState
    handles.pauseState = true;
    set(handles.pushPause,'String','Resume');
    guidata(hObject,handles);
else
    handles.pauseState = false;
    set(handles.pushPause,'String','Pause');
    guidata(hObject,handles);
end;

% --- Executes on button press in pushStop.
function pushStop_Callback(hObject, eventdata, handles)
% hObject    handle to pushStop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.stopState = 1;
guidata(hObject,handles);