function varargout = demo2_d(varargin)
% Improve functionality of the equalizer by adding sliders to control
% filter gains in real-time.
% Author: G.Wakefield, 08OCT14, EECS452F14, University of Michigan
%
% DEMO2_D MATLAB code for demo2_d.fig
%      DEMO2_D, by itself, creates a new DEMO2_D or raises the existing
%      singleton*.
%
%      H = DEMO2_D returns the handle to a new DEMO2_D or the handle to
%      the existing singleton*.
%
%      DEMO2_D('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DEMO2_D.M with the given input arguments.
%
%      DEMO2_D('Property','Value',...) creates a new DEMO2_D or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before demo2_d_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to demo2_d_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help demo2_d

% Last Modified by GUIDE v2.5 06-Oct-2014 15:23:11

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @demo2_d_OpeningFcn, ...
    'gui_OutputFcn',  @demo2_d_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before demo2_d is made visible.
function demo2_d_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to demo2_d (see VARARGIN)

% Choose default command line output for demo2_d
handles.output = hObject;

set([handles.pushPlay handles.pushPause handles.pushStop],'Enable','off');
handles.pauseState = false;
handles.stopState = false;

handles.eqSliders = [handles.sliderBass handles.sliderMidRange handles.sliderTreble];
set(handles.eqSliders,'Min',-40,'Max',0,'Value',-8);

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes demo2_d wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = demo2_d_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushLoad.
function pushLoad_Callback(hObject, eventdata, handles)
% hObject    handle to pushLoad (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[fName pName] = uigetfile({'*.wav; *.m4a; *.avi; *.mp3'});
handles.audFileName = [pName fName];

set(hObject,'String','Thank you','Enable','off');
set(handles.pushPlay,'Enable','on');

handles.pauseState = false;
handles.stopState = false;

guidata(hObject,handles);

% --- Executes on button press in pushPlay.
function pushPlay_Callback(hObject, eventdata, handles)
% hObject    handle to pushPlay (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% reuse the demo1_h code

set(hObject,'String','Playing...','Enable','off');
set([handles.pushPause handles.pushStop],'Enable','on');
drawnow

inAudioDev = dsp.AudioFileReader(handles.audFileName);
outAudioDev = dsp.AudioPlayer('SampleRate',inAudioDev.SampleRate);

load('demo1_IIR_Butterworth_EQ');
set([HdBass HdMidRange HdTreble],'PersistentMemory',1);

while ~isDone(inAudioDev) && ~handles.stopState
    if ~handles.pauseState
        sig = step(inAudioDev);
        
        gainBass = get(handles.sliderBass,'Value');
        gainMidRange = get(handles.sliderMidRange,'Value');
        gainTreble = get(handles.sliderTreble,'Value');
        
        aBass = 10^(gainBass/20);
        aMidRange = 10^(gainMidRange/20);
        aTreble = 10^(gainTreble/20);
        
        outsig = aBass*filter(HdBass,sig);
        outsig = outsig + aMidRange*filter(HdMidRange,sig);
        outsig = outsig + aTreble*filter(HdTreble,sig);
        
        step(outAudioDev,outsig);
    end;
    drawnow
    handles = guidata(hObject);
end

release(inAudioDev);
release(outAudioDev);

set(hObject,'String','Play Me');
set([handles.pushPlay handles.pushPause handles.pushStop],'Enable','off');
set(handles.pushLoad,'String','Load Me','Enable','on');
set(handles.pushPause,'String','Pause');

drawnow


% --- Executes on button press in pushPause.
function pushPause_Callback(hObject, eventdata, handles)
% hObject    handle to pushPause (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if ~handles.pauseState
    handles.pauseState = true;
    set(handles.pushPause,'String','Resume');
    guidata(hObject,handles);
else
    handles.pauseState = false;
    set(handles.pushPause,'String','Pause');
    guidata(hObject,handles);
end;

% --- Executes on button press in pushStop.
function pushStop_Callback(hObject, eventdata, handles)
% hObject    handle to pushStop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.stopState = 1;
guidata(hObject,handles);


% --- Executes on slider movement.
function sliderBass_Callback(hObject, eventdata, handles)
% hObject    handle to sliderBass (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function sliderBass_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sliderBass (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function sliderMidRange_Callback(hObject, eventdata, handles)
% hObject    handle to sliderMidRange (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function sliderMidRange_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sliderMidRange (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function sliderTreble_Callback(hObject, eventdata, handles)
% hObject    handle to sliderTreble (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function sliderTreble_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sliderTreble (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
