% Minimize coding conceptual clutter. Think: equalizer as system.
% Return to demo1_i and modify to support cascade/parallel
% multistage/multifilter structure. 
% Illustrate: cascade, parallel, dfilt.scalar.
% 
% Author: G.Wakefield, 08OCT14, EECS452F14, University of Michigan
% 
inAudioDev = dsp.AudioFileReader('SuperstitionSnippet.wav');
inInfo = audioinfo('SuperstitionSnippet.wav');

outAudioDev = dsp.AudioPlayer('SampleRate',inAudioDev.SampleRate);

load('demo1_IIR_Butterworth_EQ');

% create EqFilter objects as the cascade of a filter and a multiplier
EqBass = cascade(HdBass,dfilt.scalar(1));
EqMidRange = cascade(HdMidRange,dfilt.scalar(1));
EqTreble = cascade(HdTreble,dfilt.scalar(1));

% create Eq object as the parallel combination of the EqFilter objects
Eq = parallel(EqBass,EqMidRange,EqTreble);

% prep Eq for realtime execution
set(Eq,'PersistentMemory',1);

while ~isDone(inAudioDev)
    insig = step(inAudioDev);   
    outsig = filter(Eq,insig);    
    step(outAudioDev,outsig);
end

release(inAudioDev);
release(outAudioDev);

