function varargout = demo3_b(varargin)
% Integrating demo3_b_preps into GUI
% Author: G.Wakefield, 08OCT14, EECS452F14, University of Michigan
%
% DEMO3_B MATLAB code for demo3_b.fig
%      DEMO3_B, by itself, creates a new DEMO3_B or raises the existing
%      singleton*.
%
%      H = DEMO3_B returns the handle to a new DEMO3_B or the handle to
%      the existing singleton*.
%
%      DEMO3_B('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DEMO3_B.M with the given input arguments.
%
%      DEMO3_B('Property','Value',...) creates a new DEMO3_B or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before demo3_b_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to demo3_b_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help demo3_b

% Last Modified by GUIDE v2.5 07-Oct-2014 12:44:31

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @demo3_b_OpeningFcn, ...
    'gui_OutputFcn',  @demo3_b_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before demo3_b is made visible.
function demo3_b_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to demo3_b (see VARARGIN)

% Choose default command line output for demo3_b
handles.output = hObject;

set([handles.pushPlay handles.pushPause handles.pushStop],'Enable','off');
handles.pauseState = false;
handles.stopState = false;

handles.sliders = [handles.sliderFreq handles.sliderQ handles.sliderMix];
set(handles.sliderFreq,'Min',log2(100),'Max',log2(8000),'Value',log2(1000));
set(handles.sliderQ, 'Min',2,'Max',20,'Value',8);
set(handles.sliderMix,'Min',-40,'Max',0,'Value',-20);

% load('demo1_IIR_Butterworth_EQ');
handles.fs = 44100;
handles.half_fs = handles.fs/2;
BP_BW = 1000/8;
F3dB1 = 1000-BP_BW/2;
F3dB2 = 1000+BP_BW/2;
dBP_BW = fdesign.bandpass('N,F3dB1,F3dB2',6,F3dB1/handles.half_fs,F3dB2/handles.half_fs);
HdBP_BW = design(dBP_BW,'butter');

EqBP_BW = cascade(HdBP_BW,dfilt.scalar(1));
EqAllPass = dfilt.scalar(1);

% create Eq object as the parallel combination of the EqFilter objects
handles.Eq = parallel(EqBP_BW,EqAllPass);

% prep Eq for realtime execution
set(handles.Eq,'PersistentMemory',1);

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes demo3_b wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = demo3_b_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushLoad.
function pushLoad_Callback(hObject, eventdata, handles)
% hObject    handle to pushLoad (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[fName pName] = uigetfile({'*.wav; *.m4a; *.avi; *.mp3'});
handles.audFileName = [pName fName];

set(hObject,'String','Thank you','Enable','off');
set(handles.pushPlay,'Enable','on');

handles.pauseState = false;
handles.stopState = false;

guidata(hObject,handles);

% --- Executes on button press in pushPlay.
function pushPlay_Callback(hObject, eventdata, handles)
% hObject    handle to pushPlay (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% reuse the demo1_h code

set(hObject,'String','Playing...','Enable','off');
set([handles.pushPause handles.pushStop],'Enable','on');
drawnow

inAudioDev = dsp.AudioFileReader(handles.audFileName);

fs = inAudioDev.SampleRate;
half_fs = fs/2;
outAudioDev = dsp.AudioPlayer('SampleRate',fs);

updateRate = 2;
iC = 1;
while ~isDone(inAudioDev) && ~handles.stopState
    if ~handles.pauseState
        sig = step(inAudioDev);
        
        logF = get(handles.sliderFreq,'Value');
        Q = get(handles.sliderQ,'Value');
        gainMix = get(handles.sliderMix,'Value');
        
        handles.Eq.Stage(1).Stage(2).Gain = 10^(gainMix/20);
        handles.Eq.Stage(2).Gain = 10^((-40-gainMix)/20);
        
        if mod(iC,updateRate) == 0
            % update HdBP_BW stage
            cf = 2^logF;
            BP_BW = cf/Q;
            F3dB1 = cf-BP_BW/2;
            F3dB2 = cf+BP_BW/2;
            dBP_BW = fdesign.bandpass('N,F3dB1,F3dB2',6,F3dB1/half_fs,F3dB2/half_fs);
            HdBP_BW = design(dBP_BW,'butter');
            
            handles.Eq.Stage(1).Stage(1).sosMatrix = HdBP_BW.sosMatrix;
            handles.Eq.Stage(1).Stage(1).ScaleValues = HdBP_BW.ScaleValues;
            iC = 1;
        else
            iC = iC + 1;
        end;
        
        outsig = filter(handles.Eq,sig);
        
        step(outAudioDev,outsig);
    end;
    drawnow
    handles = guidata(hObject);
end

release(inAudioDev);
release(outAudioDev);

set(hObject,'String','Play Me');
set([handles.pushPlay handles.pushPause handles.pushStop],'Enable','off');
set(handles.pushLoad,'String','Load Me','Enable','on');
set(handles.pushPause,'String','Pause');

drawnow


% --- Executes on button press in pushPause.
function pushPause_Callback(hObject, eventdata, handles)
% hObject    handle to pushPause (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if ~handles.pauseState
    handles.pauseState = true;
    set(handles.pushPause,'String','Resume');
    guidata(hObject,handles);
else
    handles.pauseState = false;
    set(handles.pushPause,'String','Pause');
    guidata(hObject,handles);
end;

% --- Executes on button press in pushStop.
function pushStop_Callback(hObject, eventdata, handles)
% hObject    handle to pushStop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.stopState = 1;
guidata(hObject,handles);


% --- Executes on slider movement.
function sliderFreq_Callback(hObject, eventdata, handles)
% hObject    handle to sliderFreq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function sliderFreq_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sliderFreq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function sliderQ_Callback(hObject, eventdata, handles)
% hObject    handle to sliderQ (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function sliderQ_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sliderQ (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function sliderMix_Callback(hObject, eventdata, handles)
% hObject    handle to sliderMix (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function sliderMix_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sliderMix (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
